// Copyright ?Microsoft Corporation.  All rights reserved.? 
// This posting is provided AS IS?with no warranties of any kind and confers no rights.  
// Use of samples included in this posting are subject to the terms specified at http://www.microsoft.com/info/cpyright.htm.

using System;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
using System.Reflection.Emit;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

namespace GfnCompiler {
    class Program {
        static void Main(string[] args) {

            //string input = "11|22|33|44|55";
            //IEnumerator enumerator = new Regex(@"\d+|").Matches(input).GetEnumerator();
            //while (enumerator.MoveNext()) {
            //    Console.WriteLine(((Capture)enumerator.Current).ToString());
            //}

            //Console.ReadKey();


            string source =
                @"var input = ""11|222|33|44|55"";
var arr = match input ""\d+|"";
var sb = newsb;
foreach item in arr do
    print item;
    var l = len item;
    if l eq 2 then
        var arr_ = match item ""\d"";
        foreach item_ in arr_ do
            append sb ""\r\n"";
            append sb item_;
        end;
    end;
end;
print sb;
";
            Scanner scanner = new Scanner(source);
            Parser parser = new Parser(scanner.Tokens);
            StringBuilder sb = new StringBuilder();
            parser.Result.ToString(sb, 0);
            Console.WriteLine(sb);
            new CodeGen(parser.Result, "test.exe");
        }
        static void C() {
            StringBuilder sb = new StringBuilder();
            sb.Append("\r\n11");
           
        }
        static void F() {
            string input = "11|22|33|44|55";
            Regex regex = new Regex(@"\d+");
            MatchCollection mcs = regex.Matches(input);
            var em = mcs.GetEnumerator();
            while (em.MoveNext()) {
                var match = (System.Text.RegularExpressions.Match)em.Current;
                Console.Write(match.Value);
            }
        }
        static void D() {
            DynamicMethod dm = new DynamicMethod("hello", typeof(void), new Type[] { });
            ILGenerator il = dm.GetILGenerator();
            LocalBuilder input = il.DeclareLocal(typeof(string));
            LocalBuilder regex = il.DeclareLocal(typeof(Regex));
            LocalBuilder mcs = il.DeclareLocal(typeof(MatchCollection));
            LocalBuilder mc = il.DeclareLocal(typeof(System.Text.RegularExpressions.Match));
            LocalBuilder em = il.DeclareLocal(typeof(System.Collections.IEnumerator));
            LocalBuilder b = il.DeclareLocal(typeof(bool));
            Label whileTest = il.DefineLabel();
            Label whileBody = il.DefineLabel();


            il.Emit(OpCodes.Ldstr, "11|22|33|44|55");
            il.Emit(OpCodes.Stloc, input);

            il.Emit(OpCodes.Ldstr, "\\d+");
            il.Emit(OpCodes.Newobj, typeof(Regex).GetConstructor(new[] { typeof(string) }));
            il.Emit(OpCodes.Stloc, regex);

            il.Emit(OpCodes.Ldloc, regex);
            il.Emit(OpCodes.Ldloc, input);
            il.Emit(OpCodes.Callvirt, typeof(Regex).GetMethod("Matches", new[] { typeof(string) }));
            il.Emit(OpCodes.Stloc, mcs);

            il.Emit(OpCodes.Ldloc, mcs);
            il.Emit(OpCodes.Callvirt, typeof(MatchCollection).GetMethod("GetEnumerator"));
            il.Emit(OpCodes.Stloc, em);
            il.Emit(OpCodes.Br_S, whileTest);

            il.MarkLabel(whileBody);
            il.Emit(OpCodes.Ldloc, em);
            il.Emit(OpCodes.Callvirt, typeof(System.Collections.IEnumerator).GetMethod("get_Current"));
            il.Emit(OpCodes.Castclass, typeof(System.Text.RegularExpressions.Match));
            il.Emit(OpCodes.Stloc, mc);
            il.Emit(OpCodes.Ldloc, mc);
            il.Emit(OpCodes.Callvirt, typeof(Capture).GetMethod("get_Value"));
            il.Emit(OpCodes.Call, typeof(Console).GetMethod("Write", new[] { typeof(object) }));

            il.MarkLabel(whileTest);
            il.Emit(OpCodes.Ldloc, em);
            il.Emit(OpCodes.Callvirt, typeof(System.Collections.IEnumerator).GetMethod("MoveNext"));
            il.Emit(OpCodes.Stloc, b);
            il.Emit(OpCodes.Ldloc, b);
            il.Emit(OpCodes.Brtrue_S, whileBody);

            il.Emit(OpCodes.Ret);

            Action action = (Action)dm.CreateDelegate(typeof(Action));
            action();
        }
    }
}
